Index: /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/LocalSearch/ExhaustiveHillClimbSubspace.cs
===================================================================
--- /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/LocalSearch/ExhaustiveHillClimbSubspace.cs	(revision 14450)
+++ /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/LocalSearch/ExhaustiveHillClimbSubspace.cs	(revision 14450)
@@ -0,0 +1,63 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Threading;
+using HeuristicLab.Algorithms.MemPR.Interfaces;
+using HeuristicLab.Algorithms.MemPR.Util;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Optimization;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Algorithms.MemPR.Permutation.LocalSearch {
+  [Item("Exhaustive Subspace Hillclimber (permutation)", "", ExcludeGenericTypeInfo = true)]
+  [StorableClass]
+  public class ExhaustiveHillClimbSubspace<TContext> : NamedItem, ILocalSearch<TContext>
+      where TContext : ISingleSolutionHeuristicAlgorithmContext<SingleObjectiveBasicProblem<PermutationEncoding>, Encodings.PermutationEncoding.Permutation>,
+                       IPermutationSubspaceContext {
+
+    [StorableConstructor]
+    protected ExhaustiveHillClimbSubspace(bool deserializing) : base(deserializing) { }
+    protected ExhaustiveHillClimbSubspace(ExhaustiveHillClimbSubspace<TContext> original, Cloner cloner) : base(original, cloner) { }
+    public ExhaustiveHillClimbSubspace() {
+      Name = ItemName;
+      Description = ItemDescription;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ExhaustiveHillClimbSubspace<TContext>(this, cloner);
+    }
+
+    public void Optimize(TContext context) {
+      var evalWrapper = new EvaluationWrapper<Encodings.PermutationEncoding.Permutation>(context.Problem, context.Solution);
+      var quality = context.Solution.Fitness;
+      try {
+        var result = Exhaustive.HillClimb(context.Random, context.Solution.Solution, ref quality,
+          context.Problem.Maximization, evalWrapper.Evaluate, CancellationToken.None, context.Subspace.Subspace);
+        context.IncrementEvaluatedSolutions(result.Item1);
+        context.Iterations = result.Item2;
+      } finally {
+        context.Solution.Fitness = quality;
+      }
+    }
+  }
+}
Index: /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/LocalSearch/StaticAPI/Exhaustive.cs
===================================================================
--- /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/LocalSearch/StaticAPI/Exhaustive.cs	(revision 14450)
+++ /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/LocalSearch/StaticAPI/Exhaustive.cs	(revision 14450)
@@ -0,0 +1,56 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Threading;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.PermutationEncoding;
+
+namespace HeuristicLab.Algorithms.MemPR.Permutation.LocalSearch {
+  public static class Exhaustive {
+#if DEBUG
+    private const bool VALIDATE = true;
+#else
+  private const bool VALIDATE = false;
+#endif
+
+    public static Tuple<int, int> HillClimb(IRandom random, Encodings.PermutationEncoding.Permutation perm,
+      ref double quality, bool maximization, Func<Encodings.PermutationEncoding.Permutation, double> eval,
+      CancellationToken token, bool[,] noTouch = null) {
+      if (double.IsNaN(quality)) quality = eval(perm);
+      Tuple<int, int> changes;
+      switch (perm.PermutationType) {
+        case PermutationTypes.Absolute:
+          changes = ExhaustiveSwap2.HillClimb(random, perm, ref quality, maximization, eval, token, noTouch);
+          break;
+        case PermutationTypes.RelativeDirected:
+          changes = Exhaustive1Shift.HillClimb(random, perm, ref quality, maximization, eval, token, noTouch);
+          break;
+        case PermutationTypes.RelativeUndirected:
+          changes = Exhaustive2Opt.HillClimb(random, perm, ref quality, maximization, eval, token, noTouch);
+          break;
+        default: throw new ArgumentException(string.Format("Permutation type {0} is not known", perm.PermutationType));
+      }
+      if (VALIDATE && !perm.Validate()) throw new ArgumentException("HillClimb produced invalid child");
+      return changes;
+    }
+  }
+}
Index: /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/LocalSearch/StaticAPI/Exhaustive1Shift.cs
===================================================================
--- /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/LocalSearch/StaticAPI/Exhaustive1Shift.cs	(revision 14450)
+++ /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/LocalSearch/StaticAPI/Exhaustive1Shift.cs	(revision 14450)
@@ -0,0 +1,72 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Threading;
+using HeuristicLab.Algorithms.MemPR.Util;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.PermutationEncoding;
+
+namespace HeuristicLab.Algorithms.MemPR.Permutation.LocalSearch {
+  public static class Exhaustive1Shift {
+    public static Tuple<int, int> HillClimb(IRandom random, Encodings.PermutationEncoding.Permutation perm,
+      ref double quality, bool maximization, Func<Encodings.PermutationEncoding.Permutation, double> eval,
+      CancellationToken token, bool[,] noTouch = null) {
+      var current = perm;
+      if (double.IsNaN(quality)) quality = eval(current);
+      TranslocationMove lastSuccessMove = null;
+      int steps = 0, evaluations = 0;
+      while (true) {
+        foreach (var shift in ExhaustiveInsertionMoveGenerator.Generate(current)) {
+          if (lastSuccessMove != null && shift.Index1 == lastSuccessMove.Index1 && shift.Index2 == lastSuccessMove.Index2 && shift.Index3 == lastSuccessMove.Index3) {
+            // been there, done that
+            lastSuccessMove = null;
+            break;
+          }
+          var prev1 = shift.Index1 - 1;
+          var next1 = (shift.Index1 + 1) % current.Length;
+          if (prev1 < 0) prev1 += current.Length;
+          var prev3 = shift.Index3 - 1;
+          var next3 = (shift.Index3 + 1) % current.Length;
+          if (prev3 < 0) prev3 += current.Length;
+          if (noTouch != null && ((noTouch[current[prev1], current[shift.Index1]] || noTouch[current[shift.Index1], current[next1]]
+                                || noTouch[current[prev3], current[shift.Index3]] || noTouch[current[shift.Index3], current[next3]])))
+            continue;
+          TranslocationManipulator.Apply(current, shift.Index1, shift.Index2, shift.Index3);
+          var q = eval(current);
+          evaluations++;
+          if (FitnessComparer.IsBetter(maximization, q, quality)) {
+            steps++;
+            quality = q;
+            lastSuccessMove = shift;
+          } else TranslocationManipulator.Apply(current, shift.Index3, shift.Index3, shift.Index1);
+
+          if (token.IsCancellationRequested) {
+            lastSuccessMove = null;
+            break;
+          }
+        }
+        if (lastSuccessMove == null) break;
+      }
+      return Tuple.Create(steps, evaluations);
+    }
+  }
+}
Index: /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/LocalSearch/StaticAPI/Exhaustive2Opt.cs
===================================================================
--- /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/LocalSearch/StaticAPI/Exhaustive2Opt.cs	(revision 14450)
+++ /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/LocalSearch/StaticAPI/Exhaustive2Opt.cs	(revision 14450)
@@ -0,0 +1,69 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Threading;
+using HeuristicLab.Algorithms.MemPR.Util;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.PermutationEncoding;
+
+namespace HeuristicLab.Algorithms.MemPR.Permutation.LocalSearch {
+  public static class Exhaustive2Opt {
+    public static Tuple<int, int> HillClimb(IRandom random, Encodings.PermutationEncoding.Permutation perm,
+      ref double quality, bool maximization, Func<Encodings.PermutationEncoding.Permutation, double> eval,
+      CancellationToken token, bool[,] noTouch = null) {
+      var current = perm;
+      if (double.IsNaN(quality)) quality = eval(current);
+      InversionMove lastSuccessMove = null;
+      int steps = 0, evaluations = 0;
+      while (true) {
+        foreach (var opt in ExhaustiveInversionMoveGenerator.Generate(current)) {
+          if (lastSuccessMove != null && opt.Index1 == lastSuccessMove.Index1 && opt.Index2 == lastSuccessMove.Index2) {
+            // been there, done that
+            lastSuccessMove = null;
+            break;
+          }
+          var prev = opt.Index1 - 1;
+          var next = (opt.Index2 + 1) % current.Length;
+          if (prev < 0) prev += current.Length;
+          if (noTouch != null && ((noTouch[current[prev], current[opt.Index1]]) || (noTouch[current[opt.Index2], current[next]])))
+            continue;
+
+          InversionManipulator.Apply(current, opt.Index1, opt.Index2);
+          var q = eval(current);
+          evaluations++;
+          if (FitnessComparer.IsBetter(maximization, q, quality)) {
+            steps++;
+            quality = q;
+            lastSuccessMove = opt;
+          } else InversionManipulator.Apply(current, opt.Index1, opt.Index2);
+
+          if (token.IsCancellationRequested) {
+            lastSuccessMove = null;
+            break;
+          }
+        }
+        if (lastSuccessMove == null) break;
+      }
+      return Tuple.Create(steps, evaluations);
+    }
+  }
+}
Index: /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/LocalSearch/StaticAPI/ExhaustiveSwap2.cs
===================================================================
--- /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/LocalSearch/StaticAPI/ExhaustiveSwap2.cs	(revision 14450)
+++ /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/LocalSearch/StaticAPI/ExhaustiveSwap2.cs	(revision 14450)
@@ -0,0 +1,71 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Threading;
+using HeuristicLab.Algorithms.MemPR.Util;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.PermutationEncoding;
+
+namespace HeuristicLab.Algorithms.MemPR.Permutation.LocalSearch {
+  public static class ExhaustiveSwap2 {
+    public static Tuple<int, int> HillClimb(IRandom random, Encodings.PermutationEncoding.Permutation perm,
+      ref double quality, bool maximization, Func<Encodings.PermutationEncoding.Permutation, double> eval,
+      CancellationToken token, bool[,] noTouch = null) {
+      var current = perm;
+      if (double.IsNaN(quality)) quality = eval(current);
+      Swap2Move lastSuccessMove = null;
+      int steps = 0, evaluations = 0;
+      while (true) {
+        foreach (var swap in ExhaustiveSwap2MoveGenerator.Generate(current)) {
+          if (lastSuccessMove != null && swap.Index1 == lastSuccessMove.Index1 && swap.Index2 == lastSuccessMove.Index2) {
+            // been there, done that
+            lastSuccessMove = null;
+            break;
+          }
+          if (noTouch != null && (noTouch[swap.Index1, 0] || noTouch[swap.Index2, 0]))
+            continue;
+
+          var h = current[swap.Index1];
+          current[swap.Index1] = current[swap.Index2];
+          current[swap.Index2] = h;
+          var q = eval(current);
+          evaluations++;
+          if (FitnessComparer.IsBetter(maximization, q, quality)) {
+            steps++;
+            quality = q;
+            lastSuccessMove = swap;
+          } else {
+            current[swap.Index2] = current[swap.Index1];
+            current[swap.Index1] = h;
+          }
+
+          if (token.IsCancellationRequested) {
+            lastSuccessMove = null;
+            break;
+          }
+        }
+        if (lastSuccessMove == null) break;
+      }
+      return Tuple.Create(steps, evaluations);
+    }
+  }
+}
